%
% LUNG EXCHANGE SIMULATIONS
% 
% Multi-Donor Organ Exchange 
% by Haluk Ergin, Tayfun Sonmez, and M. Utku Unver
% 
% Part of Supplementary Appendix
% 
% Patient generator function for MATLAB
% (c) Ergin, Sonmez, Unver 2014
%
%
function [Patient_list, Comp1, Comp2, TTlist]=...
    createpatientDICH_LUNG_exchange_JAPAN_1(n, ABO_distp, ABO_distd,...
    hum_we_mu,hum_we_sig,hum_we_min,hum_we_max,size_comp_true);

ABOComp1=zeros(n,n);     %ABOComp(i,j)=1 means that patient i and donor j are ABOComple
ABOComp2=zeros(n,n);     %ABOComp(i,j)=1 means that patient i and donor j are ABOComple
Comp1=zeros(n,n);        %Comp(i,j)=1 means that patient i and donor j are ABOComple and  negative crossmatch
Comp2=zeros(n,n);
totalgen=0;             %how many trials were needed to generate the n pair list
Patient_list=[];
TTlist=zeros(4,4,4);
for i=1:n
    totalgen=totalgen+1;
    Newcome=rand(3,1);
    
    for kk=1:3
        z=1;
        if kk==1        
            ABOdist=ABO_distp;        
        else
            ABOdist=ABO_distd;
        end;        
        while Newcome(kk)>ABOdist(z)
            z=z+1;
        end;        
        if kk==1
            pb=z;
        elseif kk==2
            db1=z;
        else
            db2=z;
        end;
    end;
    if db2<db1
        btemp=db2;
        db2=db1;
        db1=btemp;
    end;
    TTlist(pb,db1,db2)=...
        TTlist(pb,db1,db2)+1;
    hu_wes=trunrndn([1 3],hum_we_mu,hum_we_sig,hum_we_min,hum_we_max);
    newpat=[pb db1 db2 hu_wes];
    Patient_list=[Patient_list;newpat];
end;

for i=1:n                %patient
    for j=1:n            %donors
        if Patient_list(j,2)==1
            ABOComp1(i,j)=1;
        elseif Patient_list(i,1)==4
            ABOComp1(i,j)=1;
        elseif Patient_list(j,2)==Patient_list(i,1)
            ABOComp1(i,j)=1;
        end;
        if Patient_list(j,3)==1
            ABOComp2(i,j)=1;
        elseif Patient_list(i,1)==4
            ABOComp2(i,j)=1;
        elseif Patient_list(j,3)==Patient_list(i,1)
            ABOComp2(i,j)=1;
        end;      
        if size_comp_true
             Comp1(i,j)=ABOComp1(i,j)&(Patient_list(i,4)<=Patient_list(j,5));
             Comp2(i,j)=ABOComp2(i,j)&(Patient_list(i,4)<=Patient_list(j,6));
        else
             Comp1(i,j)=ABOComp1(i,j);
             Comp2(i,j)=ABOComp2(i,j);
        end;
    end;   %for j
end;    %for i
SelfComp=zeros(n,1);
for i=1:n
    SelfComp(i)=Comp1(i,i)*Comp2(i,i);
end;
Patient_list=[Patient_list SelfComp];

