%
% LUNG and DUAL-GRAFT LIVER EXCHANGE SIMULATIONS
% 
% Multi-Donor Organ Exchange 
% by Haluk Ergin, Tayfun Sonmez, and M. Utku Unver
% 
% Part of Supplementary Appendix G
% 
% k-way exchange maximization function for lung exchange for MATLAB 
% 
% (c) Ergin, Sonmez, Unver 2014
%

function [Matched_true, num_matched, Mu]=...
    wMAX_K_WAY_lung_exchange(n,Cyc_size,Cycles,In_cyc,W_cyc,cyc_size_max,Same_pat,gen_num,cplextrue)
Matched_true=zeros(n,1);
Mu=zeros(n,2);
e=zeros(n,1);
Soln=[];
num_matched=0;
Maxw3=[];
Cycles_inc=[];
Cyc_inc_true=Cyc_size<=cyc_size_max;
Cycles_inc=Cycles(Cyc_inc_true,:);
Cyc_size_inc=Cyc_size(Cyc_inc_true);
In_cyc_inc=In_cyc(Cyc_inc_true,:);
W_cyc_inc=W_cyc(Cyc_inc_true);
for ss=1:size(Same_pat,1);
    pat1=Same_pat(ss,1);
    pat2=Same_pat(ss,2);
    a1=pat1==Cycles_inc(:,1);
    a2=pat1==Cycles_inc(:,2);
    a3=pat1==Cycles_inc(:,3);
    a4=pat1==Cycles_inc(:,4);
    b1=pat2==Cycles_inc(:,1);
    b2=pat2==Cycles_inc(:,2);
    b3=pat2==Cycles_inc(:,3);
    b4=pat2==Cycles_inc(:,4);
    ac=a1|a2|a3|a4;
    bc=b1|b2|b3|b4;
    kk=~(ac&bc);
    Cycles_inc=Cycles_inc(kk>0,:);
    In_cyc_inc=In_cyc_inc(kk>0,:);
    W_cyc_inc=W_cyc_inc(kk>0,:);
    Cyc_size_inc=Cyc_size_inc(kk>0,:);
end;
num_incc=size(In_cyc_inc,1);
xU=ones(num_incc,1);
xL=zeros(num_incc,1);
f=-Cyc_size_inc;
w=-W_cyc_inc;
A=In_cyc_inc';
bU=ones(n,1);
bL=zeros(n,1);
for ss=1:size(Same_pat,1);
    pat1=Same_pat(ss,1);
    pat2=Same_pat(ss,2);
    a1=pat1==Cycles_inc(:,1);
    a2=pat1==Cycles_inc(:,2);
    a3=pat1==Cycles_inc(:,3);
    a4=pat1==Cycles_inc(:,4);
    b1=pat2==Cycles_inc(:,1);
    b2=pat2==Cycles_inc(:,2);
    b3=pat2==Cycles_inc(:,3);
    b4=pat2==Cycles_inc(:,4);
    ac=a1|a2|a3|a4;
    bc=b1|b2|b3|b4;
    ccs=(ac|bc);
    A=[A;ccs'];
    bL=[bL;0];
    bU=[bU;1];
end;
an=size(A,1);
CTYPE=zeros(an,1);
CTYPE(1:an,1)='U';
VARTYPES=zeros(num_incc,1);
VARTYPES(1:num_incc,1)='I';
VARTYPES=char(VARTYPES);
CTYPE=char(CTYPE);
if num_incc>0
     if ~cplextrue
        [X1,FOPT,LPSOLVED,STATUS]=glpk(f,A,bU,xL,xU,CTYPE,VARTYPES,1);
    else
        VARTYPES=zeros(1,num_incc);
        VARTYPES(1,1:num_incc)='B';
        %VARTYPES
        VARTYPES=char(VARTYPES);
        [X1,FOPT,LPSOLVED,STATUS]= cplexmilp(f,A,bU,[],[],[],[],[],xL,xU,VARTYPES);
    end;
    X2=round(X1);
    %A=[A;f'];
    %bL=[bL;fmin];
    %bU=[bU;fmin];
    %X2=[];
    %CTYPE=[CTYPE;'S'];
    num_matched=round(-FOPT);
    %FOPT
    %for gg=1:gennum
    %    [X,FOPT,LPSOLVED,STATUS]=glpk(w,A,bU,xL,xU,CTYPE,VARTYPES,1);
    %    X=round(X);
    %    whi=sum(X);
    %    X2=[X2 X];
    %    A=[A;X'];
    %    bL=[bL;0];
    %    bU=[bU;whi-1];
    %    CTYPE=[CTYPE;'U'];
    %    maxw3(gg)=-w'*X;
    %end;
    %FOPT
    Soln=[X2 W_cyc_inc];
    Mu=Cycles_inc(Soln(:,1)>0,:);
    Matched_true=zeros(n,gen_num);
    we=zeros(n,gen_num);
    for gg=1:gen_num
        for cc=1:num_incc
            if X2(cc,gg)>0
                
                for kk=1:Cyc_size_inc(cc)
                    pat=Cycles_inc(cc,kk);
                    Matched_true(pat,gg)=1;    
                    
                %    we3(pat,gg)=We(pat,don);
                end;
               % we3(cycles3(cc,cycsize3(cc)),gg)=We(cycles3(cc,cycsize3(cc)),cycles3(cc,1));
            end;
        end;
    end;
    %mu3
    %pause
end;