
%
% LUNG EXCHANGE SIMULATIONS
% 
% Multi-Donor Organ Exchange 
% by Haluk Ergin, Tayfun Sonmez, and M. Utku Unver
% 
% Part of Supplementary Appendix
% 
% unrestricted maximization function for lung exchange for MATLAB
% (c) Ergin, Sonmez, Unver 2014
%

function  [Matched_true, num_matched, Mu, E_inout, E_out, E_donor, Edges, C_flow, X]=...
    wMAX_UNR_lung_exchange(n,Comp1,Comp2,cplextrue)
Mu=zeros(n,2);
Matched_true=zeros(n,1);
num_matched=0;

Comp_mat=[];
num_d=2*n;
for i=1:n
    Comp_mat=[Comp_mat Comp1(:,i) Comp2(:,i)];
end;
%wx=[];
%Comp=
C_flow=zeros(n,num_d^2);
%[inn1,jnn1,snn1]=find(Comp1);
%[inn2,jnn2,snn2]=find(Comp2);
for i=1:n
    for d1=1:num_d
        for d2=d1+1:num_d
            edge=(d1-1)*num_d+d2;
            C_flow(i,edge)=Comp_mat(i,d1)*Comp_mat(i,d2);
        end;
    end;
end;
%C
E_inout=[];
E_donor=[];
E_out=[];
xU=[];
Edges=[];
X=[];
[i_list,e_list]=find(C_flow);
if ~isempty(i_list)
    
    %find(C)
    %[i_list e_list]
    
    max_edge=size(i_list,1);
    E_inout=zeros(n,max_edge);
    E_donor=zeros(n,max_edge);
    E_out=zeros(n,max_edge);
    xU=ones(max_edge,1);
    Edges=[];
    f=-ones(max_edge,1);
    
    e1=ones(n,1);
    e0=zeros(n,1);
    
    
    for e_num=1:max_edge
        i=i_list(e_num);
        
        E_inout(i,e_num)=E_inout(i,e_num)+1;
        E_out(i,e_num)=1;
        edge=e_list(e_num);
        
        %xU(enum)=1;
        
        d1=floor((edge-1)/num_d)+1;
        d2=edge-(d1-1)*num_d;
        
        p_d2=floor((d2-1)/2)+1;
        p_d1=floor((d1-1)/2)+1;
        if p_d1~=p_d2
            if mod(d1,2)==1
                E_donor(p_d1,e_num)=1;
            elseif mod(d1,2)==0
                E_donor(p_d1,e_num)=-1;
            end;
            if mod(d2,2)==1
                E_donor(p_d2,e_num)=1;
            elseif mod(d2,2)==0
                E_donor(p_d2,e_num)=-1;
            end;
        end;
        Edges=[Edges; i edge d1 d2 p_d1 p_d2  E_donor(p_d1,e_num)  E_donor(p_d2,e_num)];
        E_inout(p_d1,e_num)=E_inout(p_d1,e_num)-0.5;
        E_inout(p_d2,e_num)=E_inout(p_d2,e_num)-0.5;
    end;
    
    xL=zeros(max_edge,1);
    bL=zeros(3*n,1);
     bU=[e0;e1;e0];
    A=[E_inout;E_out;E_donor];
    
    
    
    if ~isempty(A)
        if ~cplextrue
            
            CTYPE=zeros(2*n,1);
            
            CTYPE(1:n,1)='S';
            CTYPE(n+1:2*n,1)='U';
            CTYPE(2*n+1:3*n,1)='S';
            
            VARTYPES=zeros(max_edge,1);
            VARTYPES(1:max_edge,1)='I';
            
            VARTYPES=char(VARTYPES);
            CTYPE=char(CTYPE);
            
            [X,FOPT,LPSOLVED,STATUS]=glpk(f,A,bU,xL,xU,CTYPE,VARTYPES,1);
        else
            Aeq=[E_inout;E_donor];
            Aineq=E_out;
            beq=[e0;e0];
            bup=e1;
            VARTYPES=zeros(1,max_edge);
            VARTYPES(1,1:max_edge)='B';
            %VARTYPES
            VARTYPES=char(VARTYPES);
            [X,FOPT,LPSOLVED,STATUS]= cplexmilp(f,Aineq,bup,Aeq,beq,[],[],[],xL,xU,VARTYPES);
        end;
        X=round(X);
        
        d=zeros(2,1);
      
        for e_num=1:max_edge
            if X(e_num)==1
                edge=e_list(e_num);
                d(1)=floor((edge-1)/num_d)+1;           
                d(2)=edge-(d(1)-1)*num_d;
                for ii=1:2
                    Mu(i_list(e_num),ii)=round(d(ii)/2);
                end;
                Matched_true(i_list(e_num))=1;
            end;
        end;
        num_matched=sum(Matched_true);
       
    end;
end;
