
%
% DUAL-GRAFT LIVER EXCHANGE SIMULATIONS
% 
% Multi-Donor Organ Exchange 
% by Haluk Ergin, Tayfun Sonmez, and M. Utku Unver
% 
% Part of Supplementary Appendix
% 
% unrestricted maximization function for single-graft liver for MATLAB
% (c) Ergin, Sonmez, Unver 2014
%
function  [Mu_xm,eff_xm]=...
    wMAX_UNR_one_lobe_liver_exchange(n,Comp,We,samepat,NDD,XNDD,gennum,coef1,coef2,weighttrue,cplextrue);
%coef1  is the plus part of the optimization weight
%coef2 is the power part of the oprimization weight (the real weight to the power coef2
%NDD not used
Mu_xm=[]; %matchings
wexm=[]; %weight of each transplant
wmaxxm=[]; %weight of each matching found

wx=[];

[inn,jnn,snn]=find(Comp);

nmax=size(inn,1);
w=zeros(nmax,1);
f=-ones(nmax,1);

e1=ones(n,1);
e2=zeros(n,1);

E1=zeros(n,nmax);
E2=zeros(n,nmax);

spn=zeros(n,1);
spt=zeros(n,n);

for k=1:size(samepat,1);
    spn(samepat(k,1))=spn(samepat(k,1))+1;
    spt(samepat(k,1),spn(samepat(k,1)))=samepat(k,2);
end;

for ii=1:nmax
    i=inn(ii);
    E1(i,ii)=1;
    for jj=1:spn(i);
        j=spt(i,jj);
        E1(j,ii)=1;
    end;
    j=jnn(ii);
   
    w(ii)=-We(i); %maximization weight
   
    wx=[wx;We(i)]; %real weight
    E2(i,ii)=1;
    E2(j,ii)=-1;
end;

xL=zeros(nmax,1);
xU=ones(nmax,1);
bL=zeros(2*n,1);
bU=[e1;e2];
A=[E1;E2];

CTYPE=zeros(2*n,1);
CTYPE(1:n,1)='U';
CTYPE(n+1:2*n,1)='S';
VARTYPE=zeros(nmax,1);
VARTYPES(1:nmax,1)='I';
VARTYPES=char(VARTYPES);
CTYPE=char(CTYPE);

SOLNx=[];
wexm=[];
wmaxxm=[];
eff_xm=0;
matchnum=0;
gg=0;
optdone=0;


optdone=0;

if ~isempty(A)
    if ~cplextrue
        
        [X,FOPT,LPSOLVED,STATUS]=glpk(f,A,bU,xL,xU,CTYPE,VARTYPES,1);
    else
        VARTYPES=zeros(1,nmax);
        VARTYPES(1,1:nmax)='B';
        
        VARTYPES=char(VARTYPES);
        [X,FOPT,LPSOLVED,STATUS]=cplexmilp(f,A,bU,[],[],[],[],[],xL,xU,VARTYPES);
    end;
    X=round(X);
    eff_xm=-f'*X;
    FOPT=-eff_xm;
    mu1=zeros(n,1);
   
    if sum(X)==0
        optdone=1;
        Mu_xm=[Mu_xm zeros(n,gennum-gg+1)];
        wmaxxm=[wmaxxm;zeros(1,gennum-gg+1)];
    end;
    
    if weighttrue
        A=[A;f'];
        bL=[bL;FOPT];
        bU=[bU;FOPT];
        CTYPE=[CTYPE;'S'];
        
        gg=gg+1;
        if ~cplextrue
            [X,FOPT,LPSOLVED,STATUS]=glpk(w,A,bU,xL,xU,CTYPE,VARTYPES,1);
        else
            [X,FOPT,LPSOLVED,STATUS]=cplexmilp(w,A,bU,[],[],[],[],[],xL,xU,VARTYPES);
        end;
        X=round(X);
        FOPT;
        if sum(X)==0
            optdone=1;
            Mu_xm=[Mu_xm zeros(n,gennum-gg+1)];
            wmaxxm=[wmaxxm;zeros(1,gennum-gg+1)];
        else
            if gg==1
                eff_xm=sum(X);
            end;
            matchnum=matchnum+1;
            A=[A;f'];
            bL=[bL;w'*X];
            bU=[bU;0];
            CTYPE=[CTYPE;'U'];
            wmaxxm=[wmaxxm;wx'*X];
            if ~optdone
                mu1=zeros(n,1);
                for i=1:nmax
                    if X(i)
                        mu1(inn(i))=jnn(i);
                    end;
                end;
            end;
            Mu_xm=[Mu_xm mu1];
            
        end;
        
        
       
        
        SOLNxm=[];
        cycxm=[];
        mxncyclen=0;
        wexm=[];
       
    else
        gg=gg+1;
        
        mu1=zeros(n,1);
        for i=1:nmax
            if X(i)
                mu1(inn(i))=jnn(i);
            end;
        end;
        
        Mu_xm=[Mu_xm mu1];
        
    end;
end;