%
% SLK EXCHANGE SIMULATIONS
% 
% Multi-Donor Organ Exchange 
% by Haluk Ergin, Tayfun Sonmez, and M. Utku Unver
% 
% Part of Supplementary Appendix
% 
% Function to find all 2-way cycles for SLK exchange for MATLAB
% (c) Ergin, Sonmez, Unver 2014
%
function [num_cyc, Cyc_size, Cycles, In_cyc, W_cyc]=...
    wfind_cyc_size2_SLK_exchange(n_KA,n_SLK,n_LA,Comp_K,Comp_L,We)

n=n_KA+n_SLK+n_LA;
In_cyc=[];
Cyc_size=[];
Cycles=[];
In_cyc=[];
W_cyc=[];
num_cyc=0;
for i=1:n_KA
    for j=i+1:n_KA
        if Comp_K(i,j)&Comp_K(j,i)
            Cycles=[Cycles;[i j 0 0 0]];
            W_cyc=[W_cyc;We(i)+We(j)];
            Cyc_size=[Cyc_size;2];
            num_cyc=num_cyc+1;
            a=zeros(1,n);
            a(i)=1;
            a(j)=1;
            In_cyc=[In_cyc; a];
        end;
    end;
    for j=n_KA+1:n_KA+n_SLK
        if Comp_K(i,j)&Comp_K(j,i)&Comp_L(j,j)
            Cycles=[Cycles;[i j 0 0 0]];
            W_cyc=[W_cyc;We(i)+We(j)];
            Cyc_size=[Cyc_size;2];
            num_cyc=num_cyc+1;
            a=zeros(1,n);
            a(i)=1;
            a(j)=1;
            In_cyc=[In_cyc; a];
        end;
        for k=n_KA+n_SLK+1:n
            if Comp_K(i,j)&Comp_K(j,i)&Comp_L(j,k)&Comp_L(k,j)
                Cycles=[Cycles;[i j k 0 0]];
                W_cyc=[W_cyc;We(i)+We(j)+We(k)];
                Cyc_size=[Cyc_size;3];
                num_cyc=num_cyc+1;
                a=zeros(1,n);
                a(i)=1;
                a(j)=1;
                a(k)=1;
                In_cyc=[In_cyc; a];
            end
        end;
    end;
    
end;
for i=n_KA+1:n_KA+n_SLK
    for j=i+1:n_KA+n_SLK
        if (Comp_K(i,j)&&Comp_K(j,i)&&((Comp_L(i,j)&&Comp_L(j,i))||(Comp_L(i,i)&&Comp_L(j,j))))...
                ||(Comp_K(i,i)&&Comp_K(j,j)&&Comp_L(i,j)&&Comp_L(j,i))        
            Cycles=[Cycles;[i j 0 0 0]];
            W_cyc=[W_cyc;We(i)+We(j)];
            Cyc_size=[Cyc_size;2];
            num_cyc=num_cyc+1;
            a=zeros(1,n);
            a(i)=1;
            a(j)=1;
            In_cyc=[In_cyc; a];
        end;
    end;
    for j=n_KA+n_SLK+1:n
         if Comp_K(i,i)&Comp_L(i,j)&Comp_L(j,i)
            Cycles=[Cycles;[i j 0 0 0]];
            W_cyc=[W_cyc;We(i)+We(j)];
            Cyc_size=[Cyc_size;2];
            num_cyc=num_cyc+1;
            a=zeros(1,n);
            a(i)=1;
            a(j)=1;
            In_cyc=[In_cyc; a];
        end;
    end;
end;
for i=n_KA+n_SLK+1:n
    for j=i+1:n
        if Comp_L(i,j)&Comp_L(j,i)
            Cycles=[Cycles;[i j 0 0 0]];
            W_cyc=[W_cyc;We(i)+We(j)];
            Cyc_size=[Cyc_size;2];
            num_cyc=num_cyc+1;
            a=zeros(1,n);
            a(i)=1;
            a(j)=1;
            In_cyc=[In_cyc; a];
        end;
    end;
end;

