%
% DUAL-GRAFT LIVER EXCHANGE SIMULATIONS
% 
% Multi-Donor Organ Exchange 
% by Haluk Ergin, Tayfun Sonmez, and M. Utku Unver
% 
% Part of Supplementary Appendix
% 
% Function to find all cycles for single-graft liver exchange for MATLAB
% (c) Ergin, Sonmez, Unver 2014
%
function [num,cycsize,cycles,in_cyc,wcyc]=...
    wfind_cyc_sizeupto4_one_lobe_liver_exchange(Comp,We,NDD,max_cyc_size,weight_true);
%pack;
n=size(Comp,1);
n4=0;
cycs4=[];
n3=0;
cycs3=[];
n2=0;
cycs2=[];
n1=0;
cycs1=[];
C=[];
for i=1:n
    C=[C Comp(i,:)];
end;
cycles=[];
in_cyc=[];
cycsize=[];
cycles=[];
in_cyc=[];
num=0;
cycsize=[];
y1=[];
if max_cyc_size==4
    CS=sparse(kron(ones(1,n),C));
    %'---forming Chains ---'
    for i=1:n
        a=Comp(i,:);
        c1=sparse(kron(a,ones(1,n)));
        c2=sparse(c1.*C);
        c3=sparse(kron(c2,ones(1,n)));
        c4=c3.*CS;
        [x,y]=find(c4);
        y1=[y1 y+n^3*(i-1)];
    end;
    ns(1)=n^3;
    ns(2)=n^2;
    ns(3)=n;
    i1=floor((y1-1)/ns(1))+1;
    y2=y1-(i1-1)*ns(1);
    i2=floor((y2-1)/ns(2))+1;
    y3=y2-(i2-1)*ns(2);
    i3=floor((y3-1)/ns(3))+1;
    i4=y3-(i3-1)*ns(3);
    CCmax=[i1;i2;i3;i4];
    iCyc1=(i1==i2);
    tt2=(i1~=i2)&(i2~=i3);
    tt3=((i1~=i3)&i3~=i4)&(i4~=i2);
    gt2=i2>i1;
    gt3=i3>i1;
    gt4=i4>i1;
    iCyc1=(i1==i2);
    iCyc2=~iCyc1&tt2&(i3==i1)&gt2;
    iCyc3=~iCyc1&~iCyc2&tt2&tt3&(i4==i1)&gt2&gt3;
    iCyc4=~iCyc1&~iCyc2&~iCyc3&gt2&gt3&gt4&tt2&tt3&(i1~=i4);
    ind=C((i4-1)*n+i1);
    iCyc4=iCyc4&(ind>0);
    cycs4=(CCmax(:,iCyc4));
    n4=size(cycs4,2);
    %fprintf('---- CYC 4 FOUND---- \n');
end;
if max_cyc_size>=3
    if max_cyc_size<4
        CS=sparse(kron(ones(1,n),C));
    end;
    %3-way cycles
    c1=sparse(kron(C,ones(1,n)));
    c2=sparse(c1.*CS);
    [x,y1]=find(c2);
    ns(1)=n^2;
    ns(2)=n;
    i1=floor((y1-1)/ns(1))+1;
    y2=y1-(i1-1)*ns(1);
    i2=floor((y2-1)/ns(2))+1;
    i3=y2-(i2-1)*ns(2);
    CCmax=[i1;i2;i3;zeros(1,size(y1,2))];
    iCyc1=(i1==i2);
    tt2=(i1~=i2)&(i2~=i3);
    gt2=i2>i1;
    gt3=i3>i1;
    iCyc2=~iCyc1&tt2&(i3==i1)&gt2;
    iCyc3=~iCyc1&~iCyc2&gt2&gt3&tt2&(i1~=i3);
    ind=C((i3-1)*n+i1);
    iCyc3=iCyc3&(ind>0);
    cycs3=CCmax(:,iCyc3);
    n3=size(cycs3,2);
    %fprintf('--- CYCS 3 FOUND ---');
end;
if max_cyc_size>=2
    C2=Comp.*Comp';
    [x2,y2]=find(C2);
    on2=(x2<y2);
    n2=sum(on2);
    cycs2=[x2(on2) y2(on2) zeros(n2,1) zeros(n2,1)]';
    %fprintf('--- CYCS 2 FOUND ---');
end;
if max_cyc_size>=1
    cycs1=[];
    for i=1:n
        if Comp(i,i)>0
            cycs1=[cycs1;i 0 0 0];
        end;
    end;
    cycs1=cycs1';
    if ~isempty(cycs1)
        n1=size(cycs1,2);
    else
        n1=0;
    end;
    %fprintf('--- CYCS 1 FOUND ---- ');
end;
cycles=full([cycs1';cycs2';cycs3';cycs4']);
cycsize=[ones(n1,1);2*ones(n2,1);3*ones(n3,1);4*ones(n4,1)];
num=n1+n2+n3+n4;
%pack;
in_cyc=[];
wcyc=[];
if num>0
    wcyc=zeros(num,1);
    for i=1:n        
        a1=(cycles(:,1)==i)|(cycles(:,2)==i)|(cycles(:,3)==i)|(cycles(:,4)==i);
        in_cyc=[in_cyc a1];
    end;
    realcycsize=cycsize;
    for ii=1:size(NDD,1);
        i=NDD(ii);
        a1=in_cyc(:,i);
        if sum(a1)~=0
            cycsize(a1>0)=cycsize(a1>0)-1;
        end;
    end;
    if weight_true
        for ii=1:n1
            wcyc(ii)=We(cycs1(1,ii));
        end;
        
        for ii=n1+1:n1+n2
            wcyc(ii)=We(cycs2(1,ii-n1))+We(cycs2(2,ii-n1));
        end;
        
        for ii=n1+n2+1:n1+n2+n3
            
            %incyc(i,cycs3(1:3,i-n1-n2)')=1;
            wcyc(ii)=We(cycs3(1,ii-n1-n2))+...
                We(cycs3(2,ii-n1-n2))+...
                We(cycs3(3,ii-n1-n2));
        end;
        for ii=n1+n2+n3+1:n1+n2+n3+n4
            wcyc(ii)=We(cycs4(1,ii-n1-n2-n3))+...
                We(cycs4(2,ii-n1-n2-n3))+...
                We(cycs4(3,ii-n1-n2-n3))+...
                We(cycs4(4,ii-n1-n2-n3));
        end;
        %fprintf('---- ALL CONSTRAINTS FOUND ---- \n');
    else
         %fprintf('\n');

    end;
end;
